Leetcode:15.三数之和

这道题是一道双指针解决的例题,从字面上看,能想到的暴力解法就是三重循环,但是如果数据量过大的时候,时间复杂度会很高,所以我们要想办法减少循环次数,第二个循环和第三个循环都是在前一个循环的基础上对后面的数进行遍历,所以我们可以将第二个循环和第三个循环合并成一个循环,在我们确定第二个元素之后,我们只需要移动三个元素,来看三个数是否符合要求,这里我们设置一个变量target = -numsi (i为第一个元素的下标) 这样就变成了一个两数之和。

另外题目要求我们不能有重复的三元组,所以我们可以对所给数组进行排序+当前元素与前一个元素进行比较,这样就保证了不会有重复的三元组

cpp 复制代码
class Solution {
public:
    vector<vector<int>> threeSum(vector<int>& nums) {
        int n = nums.size();
        sort(nums.begin(),nums.end());
        vector<vector<int>> vec;
        for(int i = 0;i < n-2;i++){
            int x = nums[i];
            if (x + nums[i + 1] + nums[i + 2] > 0) break; 
            if (x + nums[n - 2] + nums[n - 1] < 0) continue; 
            if(i>0&&nums[i]==nums[i-1]){
                continue;
            }
            int k = n-1,target = -nums[i];
            for(int j = i + 1;j < n-1;j++){
                if(j>i+1&&nums[j]==nums[j-1]){
                    continue;
                }
                while(j<k&&nums[j]+nums[k]>target){
                    k--;
                }
                if(j==k) break;
                if(nums[j]+nums[k]==target){
                    vec.push_back({nums[i],nums[j],nums[k]});
                }
            }
        }
        return vec;
    }
};
相关推荐
Navigator_Z32 分钟前
LeetCode //C - 1313. Decompress Run-Length Encoded List
c语言·算法·leetcode
dialect_1 小时前
CODEFORCES ROUND 1127 DIV2
开发语言·c++·算法
Nuanyt1 小时前
LeetCode Hot 100 链表专题(四)· 3 题(Java)
java·算法·leetcode·链表·双指针
灯澜忆梦1 小时前
LeetCode 1861. 旋转盒子|Go 双指针解法
算法
软件派2 小时前
生产动态数据智能风控:阈值判别、趋势预测、异常识别算法工程落地实战
前端·数据库·算法
ZhengEnCi10 小时前
模型训练完整流程:从数据准备到模型上线的 10 个关键步骤(全文可跑)
后端·算法
weixin_3077791311 小时前
RAG 面试陷阱——混合检索并非无条件优越:一个条件反转实验
人工智能·python·面试·职场和发展
吞下星星的少年·-·14 小时前
Div.3 CF 1131A题(排序,模拟)
算法·模拟·排序
圣保罗的大教堂14 小时前
leetcode 453. 最小操作次数使数组元素相等 中等
leetcode